unit Nej;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, CheckLst, Buttons, ExtCtrls;

const
  HISCORE_FILE='sources\HiScore.dat';         //soubor s nejlepmi vsledky
type
  TTabulkaNej = class(TForm)
    BitBtn1: TBitBtn;
    ListBox1: TListBox;
    Image1: TImage;
    Panel1: TPanel;
    Panel2: TPanel;
    jmena: TListBox;
    score: TListBox;
    procedure ZaradNovyRekord(NewScore: integer);
    procedure BitBtn1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    Nejhorsi: integer;
    Nejlepsi: integer;
  end;

var
  TabulkaNej: TTabulkaNej;

implementation

uses Pampuch, Rek;

{$R *.dfm}

procedure TTabulkaNej.BitBtn1Click(Sender: TObject);
begin
  Close;
end;

procedure LoadScore();
var
  FTab: TextFile;
  s: string;
begin
  AssignFile(FTab,ExtractFilePath(Application.ExeName)+HISCORE_FILE);
  try
    Reset(FTab);

    while not eof(FTab) do begin
      ReadLn(FTab, s);
      TabulkaNej.jmena.Items.Add(s);
      ReadLn(FTab, s);
      TabulkaNej.score.Items.Add(s);
    end;
    TabulkaNej.Nejlepsi:=StrToInt(TabulkaNej.score.Items[0]);
    TabulkaNej.Nejhorsi:=StrToInt(TabulkaNej.score.Items[9]);

    Wokno.HiScorer.Caption :=TabulkaNej.jmena.items[0]; //tenhle zptnej odkaz je pkn prasrna !!!
    Wokno.HiScore.Caption  :=TabulkaNej.score.items[0];

    CloseFile(FTab);
  except
    on EInOutError do ShowMessage('Nepovedlo se nast soubor s nejlepmi vsledky!!');
  end;
end;

procedure SaveScore();
var
  FTab: TextFile;
  i: integer;
begin
  AssignFile(FTab,ExtractFilePath(Application.ExeName)+HISCORE_FILE);
  try
    try
      Rewrite(FTab);

      for i:=0 to TabulkaNej.jmena.Count-1 do begin
        WriteLn(FTab, TabulkaNej.jmena.Items[i]);
        WriteLn(FTab, TabulkaNej.score.Items[i]);
      end;

    except
      on EInOutError do ShowMessage('Nepovedlo se pst do souboru s nejlepmi vsledky!!');
    end;
  finally
    try
      CloseFile(FTab);
    except
    end;
  end;
end;

procedure TTabulkaNej.ZaradNovyRekord(NewScore: integer);
var
  kam: integer;
begin
  Rekord.ShowModal;
  kam:=9;
  while (kam>=0) and (StrToInt(score.Items[kam])<NewScore) do
    dec(kam);
  score.Items.Delete(9);
  jmena.Items.Delete(9);
  inc(kam);
  score.Items.Insert(kam, IntToStr(NewScore));
  jmena.Items.Insert(kam,Rekord.MyName.Text);

  if kam=0 then begin
    Wokno.HiScore.Caption:=IntToStr(NewScore);
    Wokno.HiScorer.Caption:=Rekord.MyName.Text;
    Nejlepsi:=NewScore;
  end;
  Nejhorsi:=StrToInt(score.Items[9]);
  SaveScore;
end;

procedure TTabulkaNej.FormCreate(Sender: TObject);
begin
  LoadScore;
end;

end.
