unit Pampuch;

interface

uses
  Windows, Messages, SysUtils, Menus, ExtCtrls, Controls, StdCtrls, Classes,
  Variants,{} Graphics, Forms,
  Dialogs, DBCtrls, MMSystem, Nej;

const STEN=9;                           //kolik existuje druhu sten
      TIMING =  60{ms};                 //prodleva mezi dvema fazemi pohybu
      WAITING=5000{ms};                 //jak dlouho dostane hrac na zahajeni hry
      SAVE_FILE='.\sources\saves.sav';  //kde je soubor s uloenma

type
  TZvuk=(nic,wav,pcspeaker);

  TWokno = class(TForm)
    MainMenu: TMainMenu;
    Hra1: TMenuItem;
    Nov1: TMenuItem;
    Pause1: TMenuItem;
    Save1: TMenuItem;
    Load1: TMenuItem;
    Konec1: TMenuItem;
    Info1: TMenuItem;
    About1: TMenuItem;
    Hra11: TMenuItem;
    Hra21: TMenuItem;
    Hra31: TMenuItem;
    Hra41: TMenuItem;
    Hra12: TMenuItem;
    Hra22: TMenuItem;
    Hra32: TMenuItem;
    Hra42: TMenuItem;
    N1: TMenuItem;
    Nastaven1: TMenuItem;
    Zvuk1: TMenuItem;
    None1: TMenuItem;
    PCspeaker1: TMenuItem;
    SoundBlaster1: TMenuItem;
    abulka1: TMenuItem;
    NewRecord: TImage;
    GameOver: TImage;
    HiScore: TPanel;
    Points: TPanel;
    Panel1: TPanel;
    HiScorer: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Open1: TMenuItem;
    OpenDlg: TOpenDialog;
    procedure FormCreate(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Pause1Click(Sender: TObject);
    procedure Konec1Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure None1Click(Sender: TObject);
    procedure PCspeaker1Click(Sender: TObject);
    procedure SoundBlaster1Click(Sender: TObject);
    procedure Nov1Click(Sender: TObject);
    procedure Save(Sender: TObject);
    procedure Load(Sender: TObject);
    procedure abulka1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure Open1Click(Sender: TObject);
  private
    { Private declarations }
  public
    Zvuk: TZvuk;
    { Public declarations }
  end;

  TPotvora= class(TImage)
  private
     dX: integer;  //pohyb po mape
     dY: integer;  //pohyb po mape
  public
     mX, mY: integer;  //souradnice na mape (1..16,1..24)
     mX0, mY0: integer;//souadnice na map v poten pozici
     Faze: integer;    //faze pohybu
     Stopped: boolean; //m se animovat?
     Smer: word;       // kam jdes? (cU, cD, cL, cR);
  end;

  TPampuch= class(TPotvora)
     {...}
     constructor Create(AOwner: TComponent); override;
  private
     Pmlask: Pointer;  //mlaskav zvuk
     Smlask: String;
     Pkilled: Pointer; //zvuk umrn
     Skilled: String;
  public
     Grafika: array[1..4{faze}, 0..4{smrt+smer}] of TBitmap;
     Ziv: boolean;     //zije jeste?
     Zivotu: integer;  //poet nhradnch ivot
     Body: integer;    //kolik uz si sezral puntiku?
     KamChci: word;    //kam uzivatel naposledy zadal aby se slo (U,D,L,R)
     procedure Refresh;
     procedure ResetP;
     procedure Ovladani(Sender: TObject; var Key: Word; Shift: TShiftState);
     function Bod:boolean;  //pokusi se serat bod a pokud byl posledn vrt true
     function Oziv:boolean; //pokus se oivit Pampucha a vrt zda se to povedlo
     procedure NastavZivoty;
     procedure Mlaskni;
     procedure Zarvi;
  end;

  TRobot= class(TPotvora)
     {...}
     constructor Create(AOwner: TComponent); override;
  public
     Typ: integer;     //typ robota.. Levo-/Pravotoiv (signum)
     function Kolize: boolean;
     procedure Refresh;
     procedure ResetP;
  end;

  TRoboti= class
  public
    Grafika: array[1..4] of TBitmap;
    Robot: array[1..4] of TRobot;
    constructor Create(AOwner: TObject);
    procedure Refresh;
    procedure ResetP;
    procedure Paint;
    procedure Stop;
    destructor Destroy;override;
  end;

  TPole = class(TImage)  //polko na map
     {...}
  private
     { Private declarations }
  public
     Visitable: boolean;
     Typ: (Dot, Void, Wall);
     Hodnota: integer;
  end;

  TWorld = class
    Casovac: TTimer;
    constructor Create(AOwner: TComponent);
    destructor Destroy;override;
  public
    Level: integer;              //slo aktuln hranho kola
    sMapa: string;               //adresa mapy pro uivatelem definovan mapy
    Grafika: array[0..STEN+1] of TBitmap; //grafika mapy.. 0-void, 1..9-wall, 10-dot
    Mapa: array[1..16,1..24] of TPole;
    Tecek: Word;                 //kolik je na map jet neseranejch teek
    Recordable: boolean;         //pot se pokud bude dosaeno rekordu? (kvli Saveovn)
    isRecord: boolean;           //vsledek pat do tabulky
    procedure ResetLevel;
    procedure VytvorMapu;
    procedure NactiMapu;
    procedure NextLevel;
    procedure Animuj(Sender: TObject);
    procedure Cekej(Sender: TObject);
    procedure Paint();
    function Visitable(y, x: integer): boolean;
    procedure Wait(Time: integer);
    procedure RecordTest;
  end;

type      //datove typy pro saveovani
    TRob=Record
         Top: integer;  //souadnice na mape
         Left:integer;  //souadnice na mape
         dX: integer;  //pohyb po mape
         dY: integer;  //pohyb po mape
         mX, mY: integer;  //souradnice na mape (1..16,1..24)
         mX0, mY0: integer;//souadnice na map v poten pozici
         Faze: integer;    //faze pohybu
         Stopped: boolean; //m se animovat?
         Smer: word;       // kam jdes? (cU, cD, cL, cR);
         Typ: integer;     //typ robota.. Levo-/Pravotoiv (signum)
    end;

    GamePosition=Record
       //TWorld
         Level: integer;              //slo aktuln hranho kola
         sMapa: string[200];          //adresa mapy pro uivatelem definovan mapy
         Tecek: Word;                 //kolik je na map jet neseranejch teek
         Mapa: array[1..16,1..24] of integer;
       //TPampuch
         Top: integer;  //souadnice na mape
         Left:integer;  //souadnice na mape
         dX: integer;  //pohyb po mape
         dY: integer;  //pohyb po mape
         mX, mY: integer;  //souradnice na mape (1..16,1..24)
         mX0, mY0: integer;//souadnice na map v poten pozici
         Faze: integer;    //faze pohybu
         Stopped: boolean; //m se animovat?
         Smer: word;       // kam jdes? (cU, cD, cL, cR);
         Ziv: boolean;     //zije jeste?
         Zivotu: integer;  //poet nhradnch ivot
         Body: integer;    //kolik uz si sezral puntiku?
       //TRoboti
         Rob: array[1..4] of TRob;
     end;


const
  cS=0;cU=1;  cD=2;     cL=3;      cR=4;  //indexi do pole fazi pohybu
  KUp=38; KDown=40; KLeft=37; KRight=39;  //kody dcch klves (U,D,L,R)
  BorderU=40; BorderL=0;                  //pozice hrac plochy na formuli
  B_H=25; B_W=25;                         //rozmry bloku

var
  Wokno: TWokno;
  {}Svet: TWorld;                             //ve co se dje
  {**}Roboti: TRoboti;                        //zli roboti
  {**}Pampusak: TPampuch;                     //Pampuch
  {**>>}Zivoty: array[1..4] of TImage;        //nahradni zivoty

//******************************************************
//********************* KONEC TYPE *********************
//******************************************************

implementation

uses Oaplikaci;

{$R *.dfm}

//********************** nepiazeno !!!
function sgn(cislo: integer):integer;   //vraci znamenko
begin
  if      cislo>0 then sgn:=1
  else if cislo=0 then sgn:=0
                  else sgn:=-1;
end;

procedure NahradniZivoty;        //vytovri na halde polozky pro obrazky nahr.zivou
var
  k: integer;
begin
  for k:=1 to 4 do begin
    Zivoty[k]:=TImage.Create(Wokno);
    with Zivoty[k] do begin
      Parent:=Wokno;
      Width:=21;
      Height:=21;
      Top:=8;
      Left:=Wokno.Points.Left+Wokno.Points.Width {430}+20 + Width*(k-1);
      Picture.LoadFromFile('.\images\Life.bmp');
      Transparent:=True;
      Visible:=True;
    end;
  end;
end;

{********************** tWorld **********************}

constructor TWorld.Create(AOwner: TComponent);
begin
  inherited Create();
  Casovac:=TTimer.Create(AOwner);
  Casovac.Enabled:=False;
  Casovac.Interval:=TIMING;
  Casovac.OnTimer:=Svet.Animuj;


  VytvorMapu;  //vytvo poloky mapy
  Level :=0;   //potom se zavola nextlevel a tim nabehne 1.kolo
  Recordable:=True;
  isRecord:=False;
end;

procedure TWorld.Wait(Time:integer);//dava uzivateli cas na rozkoukani
begin
  Paint;
  Casovac.Interval:=Time;
  Casovac.OnTimer:=Svet.Cekej;
  Casovac.Enabled:=True;
end;
procedure TWorld.Cekej(Sender: TObject); //cas na rozkoukani vyprsel
begin
  Casovac.Interval:=TIMING;
  Casovac.OnTimer:=Svet.Animuj;
end;

procedure TWorld.RecordTest;             //testuje, bylo-li dosaeno rekordu
begin
  if not Recordable then begin
    exit;
  end;
  if Pampusak.Body>TabulkaNej.Nejhorsi then begin       //bude zaazen do tabulky
     isRecord:=True; //nastavit, ze rekord byl
  end;
  if Pampusak.Body>TabulkaNej.Nejlepsi then begin       //zobraz ikonu NewRecord
      Wokno.NewRecord.Visible:=True;
  end else Wokno.NewRecord.Visible:=False;
end;

procedure TWorld.VytvorMapu;   //vytvori na halde policka mapy
var i,j: integer;
begin
  //nacti grafiku
  for i:=0 to STEN+1 do Grafika[i]:=TBitmap.Create;//vytvor polozky

    for i:=1 to STEN do begin
      try
        Grafika[i].LoadFromFile(ExtractFilePath(Application.ExeName)+'images\Wall_'+IntToStr(i)+'.bmp');  //nacti steny
      except
        on Exception do Grafika[i].LoadFromFile(ExtractFilePath(Application.ExeName)+'images\Void.bmp');  //mapa nedef
      end;
    end;

    Grafika[0].LoadFromFile(ExtractFilePath(Application.ExeName)+'images\Void.bmp');              //nacti prazdou pozici
    Grafika[STEN+1].LoadFromFile(ExtractFilePath(Application.ExeName)+'images\Dot.bmp');              //nacti tecku

  for i:=1 to 16 do              //vytvo polka
  for j:=1 to 24 do begin
    Mapa[i,j]:=TPole.Create(Wokno);
    With Mapa[i,j] do begin
       Parent   := Wokno;
       Height   := B_H;
       Width    := B_W;
       Top      := BorderU+(i-1)* B_W;
       Left     := BorderL+(j-1)* B_W;
       Visible  := True;
       Visitable:= True;
       OnClick  := Wokno.Pause1Click;
    end;
  end;
end;

procedure TWorld.ResetLevel;   //postav objekty na pvodn pozice
begin
   if Pampusak.Oziv then begin
     Roboti.ResetP;
     Wait(WAITING);
   end;
   //else Game Over
end;

procedure TWorld.NextLevel;    //kolo bylo dokoneno, tak nahraj dal
begin
  if Level<0 then begin
    NactiMapu;
    Pampusak.ResetP;
    Pampusak.Body:=0; Wokno.Points.Caption:='0';
    Roboti.ResetP;
    Wait(WAITING);
    exit;
  end;

  inc(Level);
  try
    sMapa:= ExtractFilePath(Application.ExeName)+'maps\level_'+IntToStr(Level)+'.map';
    NactiMapu;
    Pampusak.ResetP;
    Roboti.ResetP;
    Wait(WAITING);
  except
  on Exception do         //tak vysok kolo tu u nen... tak dme zase 1.
     begin
          if Level>1 then begin
          Wokno.Pause1Click(Wokno);
              ShowMessage('Dal kola nebyla nalezena... hra proto bude pokraovat prvnm kolem...');
          Wokno.Pause1Click(Wokno);
          Level:=0;
          NextLevel;
          end else ShowMessage('Mapa nenalezena!!!');  //kdy nenajde ani prvn mapu, tak se na ni neme vrtit
     end;
  end;
end;

procedure TWorld.NactiMapu;  //nacte mapu z fileu jmenem sMapa
var
  FMapa: TextFile;             //zdroj mapy
  Blok: char;              //znak naten ze souboru: co m na tomto poli stt
  robotu, k, l: integer;   //pomocn tae
begin
  AssignFile(FMapa,SMapa);
  try
    Reset(FMapa);
    robotu:=0;
    Tecek:=0;
    for k:=1 to 16 do                //nacti a zobraz mapu
    for l:=1 to 24 do begin
       Read(FMapa, Blok);
       With Mapa[k,l] do begin
         {Nastav obrazek}
         Case Blok of
           {nic  }   'V':  begin
                             Picture.Assign(Grafika[0]);
                             Hodnota:=0;
                             Typ := Void;
                             Visitable:= True
                           end;
           {tecka}   'D':  begin
                             Picture.Assign(Grafika[STEN+1]);
                             Hodnota:=STEN+1;
                             Typ := Dot;
                             Visitable:= True;
                             inc(Tecek);
                           end;
           {robot}   'R':  begin
                             Picture.Assign(Grafika[STEN+1]);//pod robotem je bod
                             Hodnota:=STEN+1;
                             Typ := Dot;
                             Visitable:= True;
                             inc(Tecek);

                             inc(robotu);
                             With Roboti.Robot[robotu] do begin
                               Top    := BorderU+(k-1)*B_H;
                               Left   := BorderL+(l-1)*B_W;
                               mX0    := l;
                               mY0    := k;
                               mX     := l;
                               mY     := k
                             end;
                           end;
           {pampuch} 'P':  begin
                             Picture.Assign(Grafika[0]);
                             Hodnota:=0;
                             Typ := Void;
                             Visitable:= True;

                             Pampusak.Top  := 40+(k-1)* B_H;
                             Pampusak.Left :=    (l-1)* B_W;
                             Pampusak.mY   := k;
                             Pampusak.mX   := l;
                             Pampusak.mY0  := k;
                             Pampusak.mX0  := l;
                           end;
         else
           {stena} Picture.Assign(Grafika[StrToInt(Blok)]);
                   Hodnota:=StrToInt(Blok);
                   Visitable := False;
         end;
       end;
      end;
  finally
    CloseFile(FMapa);
  end;
end;

procedure TWorld.Paint; //prekresli vsechny objekty
var i,j: integer;
begin
  for i:=1 to 16 do
  for j:=1 to 24 do
    Mapa[i,j].Paint;
  Roboti.Paint;
  Pampusak.Paint;
end;

function TWorld.Visitable(y, x: integer): boolean; //vraci, zda je policko mapy navstivitelne
begin
  if (x<1) or (x>24) or (y<1) or (y>16) then
     Visitable:=False
  else
     Visitable:=Mapa[y, x].Visitable;
end;

procedure TWorld.Animuj(Sender: TObject); //animuje roboty a Pampucha
begin
//   SendMessage(Wokno.Handle, WM_SetRedraw, 0, 0);
   Roboti.Refresh;
   Pampusak.Refresh;  //animuj Pampuka
//   SendMessage(Wokno.Handle, WM_SetRedraw, 1, 0);
end;

destructor TWorld.Destroy;
var i,j: integer;
begin
  for i:=1 to 16 do
  for j:=1 to 24 do
    Mapa[i,j].Destroy;
  inherited Destroy;
end;

{********************** tWokno **********************}
procedure TWokno.FormCreate(Sender: TObject);
var
  k,l: integer;
  h: THandle;
begin
  Width :=24*B_W+2*BorderL+6;
  Height:=16*B_H+BorderU+45;
//  Doublebuffered := True;
  h:=LoadImage(0,                     //nati nov kurzor
               '.\images\cursor.cur',
               IMAGE_CURSOR,
               0,
               0,
               LR_DEFAULTSIZE or LR_LOADFROMFILE
               );
  l:=20;                              //a nainstaluj ho
  if h=0 then ShowMessage('Nepodailo se najt kurzor!') else
  begin
    Screen.Cursors[l] := h;
    Cursor:=l;
  end;
  Zvuk:=wav;

  NahradniZivoty;                     //zobraz nahradni zivoty

  Pampusak:= TPampuch.Create(Wokno);  //vytvor Pampucha
  Roboti := TRoboti.Create(Wokno);    //vytvor roboty
  Svet := TWorld.Create(Wokno);
  Svet.NextLevel;

  for k:=1 to 4 do Roboti.Robot[k].BringToFront;
  Pampusak.BringToFront;                    //vynes Pampucha a Roboty pred mapu
  GameOver.BringToFront;
end;

procedure TWokno.FormKeyDown(Sender: TObject; var Key: Word; //cte klavesnici a preposila pokyny pampuchovi
  Shift: TShiftState);
begin
  Pampusak.Ovladani(Sender, Key, Shift);
end;

procedure TWokno.FormDestroy(Sender: TObject);    //ukli po seb
var i: integer;
begin
  Roboti.Destroy;
  Pampusak.Destroy;
  for i:=1 to 4 do Zivoty[i].Destroy;
  Svet.Destroy;
end;

//*********************************************************
//****************************** menu *********************
//*********************************************************
procedure TWokno.Nov1Click(Sender: TObject); //Nova hra
begin
  Pampusak.ResetP;
  Pampusak.Transparent:=True;
  Pampusak.Body:= 0 ;
    Points.Caption:='0';
  Pampusak.Zivotu:=4;
  Pampusak.NastavZivoty;

  Svet.Level:=0;
  Svet.isRecord:=False;
  Svet.Recordable:=True;
  NewRecord.Visible:=False;
  Svet.NextLevel;
end;

procedure TWokno.Pause1Click(Sender: TObject);   //Pozastavit
begin
   if Pause1.Caption='&Pause' then
     begin      //zastav
       Svet.Casovac.Enabled:=False;
       Pause1.Caption:='&Pokracovat';
     end
   else  begin  //pus
      Svet.Casovac.Enabled:=True;
      Pause1.Caption:='&Pause';
   end;
end;

procedure TWokno.Konec1Click(Sender: TObject); //Konec
begin
   halt;
end;

procedure TWokno.None1Click(Sender: TObject);   //bez zvuku
begin
  Zvuk:=nic;
  TMenuItem(Sender).Checked:=true;
end;
procedure TWokno.PCspeaker1Click(Sender: TObject); //hrat pres PC-speaker
begin
  Zvuk:=pcspeaker;
  TMenuItem(Sender).Checked:=true;
end;
procedure TWokno.SoundBlaster1Click(Sender: TObject); //hrat pres zvukovku
begin
  Zvuk:=wav;
  TmenuItem(Sender).Checked:=true;
end;
//*********************************************************
//*********************************************************




{********************** tRoboti **********************}
constructor TRoboti.Create(AOwner: TObject);
var k:integer;
begin
  inherited Create;

  for k:=4 downto 1 do  begin
    Grafika[k]:=TBitmap.Create;         //vytvor polozky pohybu robota
    Grafika[k].LoadFromFile(ExtractFilePath(Application.ExeName)+'images\Robot_'+IntToStr(k)+'.bmp');

    Robot[k]:=TRobot.Create(Wokno);     //vytvor robota
    Robot[k].Name:='R'+IntToStr(k);
  end;
    Robot[2].Typ:=-1;
    Robot[4].Typ:=-1;
end;

procedure TRoboti.Refresh;  //prepocitej vsechny roboty
var j:integer;
begin
   for j:=1 to 4 do
     Robot[j].Refresh;
end;

procedure TRoboti.ResetP;    //resetuj vsechny roboty
var j:integer;
begin
   for j:=1 to 4 do
     Robot[j].ResetP;
end;

procedure TRoboti.Paint;               //prekresli vsechny roboty
var j: integer;
begin
  for j:=1 to 4 do
      Robot[j].Paint;
end;

procedure TRoboti.Stop;                //zastav vsechny roboty
var i:integer;
begin
  for i:=1 to 4 do Roboti.Robot[i].Stopped:=True;  //Zastav kolo!!!
end;

destructor TRoboti.Destroy;            // znic vsechny roboty
var i: integer;
begin
  for i:=1 to 4 do Robot[i].Destroy;
  inherited Destroy;
end;

{********************** tRobot **********************}
constructor TRobot.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  Parent := AOwner as TWinControl;         //vlastnk

  Height := B_H;
  Width  := B_W;
  Top  := BorderU;
  Left := BorderL;
  Transparent:=True;
  Picture.Assign(Pampusak.grafika[1,1]);
  OnClick  := Wokno.Pause1Click;

  ResetP;

  mX :=1; mY :=1;
  mX0:=1; mY0:=1;
  Typ:=1; //jezd dolu a doprava (v nerozhodnch situacch)

  Visible:= True;
end;

function TRobot.Kolize: boolean;    //vrati True, pokud je robot v kolizi
var i: integer;
const DIST_U = B_W-8;  //pesah max, kter jet vad (3/4)
      DIST_L = 6;      //pesah min, kter u vad    (1/4)
begin
  if (dY=0) and (dX=0) then begin //pokud stoj, tak se smruj pokad..
    Kolize:=True;
    Exit
  end;
  //kdy je pedemnou stna,
//  if Faze=1 then
    if not Svet.Visitable(mY+sgn(dY), mX+sgn(dX)) then begin
      Kolize:=True;
      Exit;
    end;

  //nebo kdy je pede mnou robot,
    for i:=1 to 4 do
      if (Roboti.Robot[i].Name[2] <> Self.Name[2]) then begin
      case Smer of      // podvej se ped sebe
        cU: if (abs(Left-Roboti.Robot[i].Left)<=DIST_U) and
                ((Top -Roboti.Robot[i].Top )<=DIST_L+B_H) and
                ((Top -Roboti.Robot[i].Top )>DIST_L) // ...a srka
             then begin
                Kolize:=True;
                Exit;
             end;
        cD: if (abs(Left-Roboti.Robot[i].Left)<=DIST_U) and
                ((Roboti.Robot[i].Top - Top)<=DIST_L+B_H) and
                ((Roboti.Robot[i].Top - Top)>DIST_L) // ...a srka
             then begin
                Kolize:=True;
                Exit;
             end;
        cR: if ((-Left+Roboti.Robot[i].Left)<=DIST_L+B_W) and
                ((-Left+Roboti.Robot[i].Left)>DIST_L) and
                (abs(Top-Roboti.Robot[i].Top )<=DIST_U) // ...a srka
             then begin
                Kolize:=True;
                Exit;
             end;
        cL: if ((Left-Roboti.Robot[i].Left)<=DIST_L+B_W) and
                ((Left-Roboti.Robot[i].Left)>DIST_L) and
                (abs(Top-Roboti.Robot[i].Top )<=DIST_U) // ...a srka
             then begin
                Kolize:=True;
                Exit;
             end;
      end;
      end;
  //pak vra True, jinak False
    Kolize:=False;
end;

procedure TRobot.ResetP;      //resetuje robota
begin
  mX:=mX0;
  mY:=mY0;

  Left   := BorderL+(mX-1)*B_W;
  Top    := BorderU+(mY-1)*B_H;

  dX:=0; dY:=-B_H div 4;  //Robote, jdi nahoru
  Faze:=1;
  Stopped:=False;
  Smer:=cU;
end;

procedure TRobot.Refresh; //peklesli Robota a otesuj jeho stav
const
  Tolerance = 0.75 ; //kolik Pampucha je teba serat, ne ho to zabije
var
  s: string[1];
begin
   if Stopped then Exit;

   if (dX+dY<>0) then  Faze:= (Faze mod 4) + 1;

   s:=IntToStr(Faze);
   if Faze=1 then begin //udruj aktuln mov bod
       mX:=mX+sgn(dX);      //pokud stojm, tak jsou dX i dY =0
       mY:=mY+sgn(dY);
   end;

   //zkontroluj kam jde, a jestli tam jt sm
   if Kolize then begin // se smruj na Pampucha
      case Smer of
        cU,cD: begin
                    if mX-Pampusak.mX>0 then begin
                      {je vlevo}
                      dX:=-B_W div 4;
                      dY:=0;
                      Smer:=cL;
                      if Kolize then begin
                        dX:=0; dY:=0;
                      end;
                    end else if mX-Pampusak.mX<0 then begin
                      {je vpravo}
                      dX:=B_W div 4;
                      dY:=0;
                      Smer:=cR;
                      if Kolize then begin
                        dX:=0; dY:=0;
                      end;
                    end else begin
                      {je pmo}
                      dY:=0;
                      if Typ=1 then begin
                        dX:= B_W div 4;
                        Smer:=cR;
                      end else begin
                        dX:= -B_W div 4;
                        Smer:=cL;
                      end;
                      if Kolize then begin
                        dX:=0; dY:=0;
                      end;
                    end;
                 end;
        cL,cR: begin
                    if mY-Pampusak.mY>0 then begin
                      {je v}
                      dX:=0;
                      dY:=-B_W div 4;
                      Smer:=cU;
                      if Kolize then begin
                        dX:=0; dY:=0;
                      end;
                    end else if mY-Pampusak.mY<0 then begin
                      {je n}
                      dX:=0;
                      dY:=B_W div 4;
                      Smer:=cD;
                      if Kolize then begin
                        dX:=0; dY:=0;
                      end;
                    end else begin
                      {je pmo}
                      dX:=0;
                      if Typ=1 then begin
                          dY:=B_W div 4;
                          Smer:=cD;
                      end else begin
                          dY:=-B_W div 4;
                          Smer:=cU;
                      end;
                      if Kolize then begin
                        dX:=0; dY:=0;
                      end;
                    end;
                 end;
      end;
   end;

   //vykresli se
   Top  := (mY-1)*B_H + BorderU + (Faze-1)*(B_H div 4)*sgn(dY);
   Left := (mX-1)*B_W + BorderL + (Faze-1)*(B_W div 4)*sgn(dX);
   if (dX+dY)<>0 then Picture.Assign(Roboti.Grafika[Faze]);

   //zkontroluj, jesti jsi neseral Pampucha
   if Pampusak.Ziv then
   if (abs(Left-Pampusak.Left)<B_W*Tolerance) and
      (abs(Top -Pampusak.Top )<B_H*Tolerance) then begin
     Pampusak.Ziv:=False;
     Pampusak.Faze:=1;
     Roboti.Stop; //zastav kolo
   end;
end;


{********************** tPampuch **********************}
constructor TPampuch.Create(AOwner: TComponent);
var
  Src: File;
  i,j,tmp: integer;
begin
  inherited Create(AOwner);
  Parent:=AOwner as TWinControl;           //vlastnik

  Width := B_W;
  Height:= B_H;
  Top := BorderU;
  Left:= BorderL;
  Transparent:=True;
  OnClick  := Wokno.Pause1Click;

  ResetP;

  mX:=1; mY:=1;
  Body:=0;
  Ziv :=True;
  Zivotu := 4;
  NastavZivoty;

  Visible:=True;

  {nati grafiku}
  for i:=1 to 4 do  //vytvor bitmapy
  for j:=0 to 4 do
    Grafika[i,j]:=TBitmap.Create;

  for i:=1 to 4 do Grafika[i,cS].LoadFromFile(ExtractFilePath(Application.ExeName)+'images\Dead_'+IntToStr(i)+'.bmp');  //nacti faze umirani

  for i:=1 to 4 do          //nacti faze pohybu
  for j:=1 to 4 do Grafika[i,j].LoadFromFile(ExtractFilePath(Application.ExeName)+'images\Pampuch_'+IntToStr(j)+IntToStr(i)+'.bmp');

  {nati zvuky}
  //mlasknut
  Smlask:=ExtractFilePath(Application.ExeName)+'sounds\Ham.wav';
  AssignFile(Src, Smlask);
  Reset(Src,1);
  Tmp := FileSize(Src);
  GetMem(Pmlask, Tmp);
  BlockRead(Src, Pmlask^, Tmp);
  CloseFile(Src);
  //umen
  Skilled:=ExtractFilePath(Application.ExeName)+'sounds\Killed.wav';
  AssignFile(Src, Skilled);
  Reset(Src,1);
  Tmp := FileSize(Src);
  GetMem(Pkilled, Tmp);
  BlockRead(Src, Pkilled^, Tmp);
  CloseFile(Src);
end;

procedure TPampuch.ResetP;      //resetuj Pampucha
begin
  Smer:=cR; dX:=0; dY:=0;  //Pampuchu, nikam nechod, ale koukej doprava

     mX  :=mX0;
     mY  :=mY0;
  Left   := BorderL+(mX-1)*B_W;
  Top    := BorderU+(mY-1)*B_H;

  Ziv:=True;
  KamChci:=KRight;         //kdyby nahodou dobehl timer pred pokynem od uzivatele, tak se rozjed kam koukas
  Faze:=1;
  Stopped:=False;
  Picture.Assign(Grafika[1,4]);     //stuj a koukej doprava
end;

procedure TPampuch.Ovladani(Sender: TObject; var Key: Word;  //prijimej prikazy z klavesnice
  Shift: TShiftState);
begin
  KamChci:=Key;
  if Svet.Casovac.Interval <> TIMING then svet.Casovac.OnTimer(Sender);
end;

procedure TPampuch.NastavZivoty;   //aktualizuje pocet nahradnich zivotu
var
  i: integer;
begin
  for i:=1 to 4 do
      Zivoty[i].Visible := (Zivotu >= i);
end;

procedure TPampuch.Mlaskni; //spolkni puntik - prehrej na zvolenem zarizeni zvuk
begin
   case Wokno.zvuk of  //pehraj na em se m pehrvat
     pcspeaker: Windows.Beep(100{Hz},1{ms});//PC-speaker
     wav:       sndPlaySound(Pmlask, SND_MEMORY or SND_ASYNC or SND_NOWAIT or SND_NOSTOP);
     nic:       ;//tady se nic nedeje
   end;
end;

function TPampuch.Bod:boolean; //am, am, dal bodk do aludku, vraci zda uz je konec kola
begin
   Result:=False;
   if Svet.Mapa[mY,mX].Typ=Dot then begin
     inc(Body);
     dec(Svet.Tecek);
     Mlaskni;
     Svet.RecordTest;     //Rekord???
     Wokno.Points.Caption := IntToStr(Body);
     Svet.Mapa[mY,mX].Typ:=Void;
     Svet.Mapa[mY,mX].Picture.Assign(Svet.Grafika[0]);
     Svet.Mapa[mY,mX].Hodnota:=0;
     if Svet.Tecek=0 then begin
       Svet.NextLevel;
       Result:=True
     end;
   end;
end;

procedure TPampuch.Zarvi;
begin
     case Wokno.zvuk of  //pehraj na em se m pehrvat
        pcspeaker: begin
                       Windows.Beep(150{Hz},100{ms});//PC-speaker
                       Windows.Beep( 70{Hz},100{ms});
                   end;
        wav:       sndPlaySound(PKilled, SND_NOWAIT or SND_MEMORY or SND_ASYNC or SND_NOSTOP);
        nic:       ;//tady se nic nedeje
     end;
end;

function TPampuch.Oziv: boolean;  //pokud ma Pampuch nahradni zivoty, tak ho oziv, protoze umrel
begin
   Dec(Zivotu);
   NastavZivoty;

   Zarvi;

   if Zivotu>=0 then begin    //vem dal ivot
     ResetP;

     Transparent:=True;
     Ziv:= True;

     Result:=True;
   end else begin             //udlej funus
     Result:=False;
     Wokno.GameOver.Visible :=True;
     Wokno.GameOver.Refresh;
     if Svet.Recordable and Svet.isRecord then begin
       TabulkaNej.ZaradNovyRekord(Body);
       Wokno.abulka1Click(Self);
     end else sleep(1000);

     //cekej chvilku
     Wokno.GameOver.Visible:=False;
   end;
end;

procedure TPampuch.Refresh; //peklesli Pampucha a spocti mu kolize
begin
   if Stopped then Exit;

   if (dX+dY<>0) or not Pampusak.Ziv then Faze:= (Faze mod 4) + 1;

   if not Ziv then begin
     Transparent:=False;        //to je fakt vokliv
     Picture.Assign(Grafika[Faze,cS]);
     if Faze=4 then begin
       Stopped:=True;
       Svet.Casovac.Enabled:=False;//abych nespadl znovu do animuj!!
       Svet.ResetLevel; //pokud mm nhradn ivoty, tak vyvol pokraovn kola
     end;
     exit;
   end;

   if (Faze=1) or (dX+dY=0) then begin
       mX:=mX+sgn(dX);
       mY:=mY+sgn(dY);

       if Bod then exit;   //pokud se prave zmenil level, tak uz se dal neanimuj ve starem

       if not Svet.Visitable(mY+sgn(dY), mX+sgn(dX)) then begin //stj, nebo naraz
         Picture.Assign(Grafika[Faze,Smer]);
         dX:=0;
         dY:=0
       end;
       case KamChci of
            KUp:    if Svet.Visitable(mY-1, mX) then begin
                        Smer:=cU;
                        dX  := 0;
                        dY  :=-Height div 4;
                    end;
            KDown:  if Svet.Visitable(mY+1, mX) then begin
                      Smer:=cD;
                      dX  := 0;
                      dY  := Height div 4;
                    end;
            KLeft:  if Svet.Visitable(mY, mX-1) then begin
                      Smer:=cL;
                      dX:=-Width div 4;
                      dY:=0;
                    end;
            KRight: if Svet.Visitable(mY, mX+1) then begin
                      Smer:=cR;
                      dX:= Width div 4;
                      dY:=0;
                    end;
       end;
       Top :=(mY-1)*B_H+BorderU;
       Left:=(mX-1)*B_W+BorderL
   end else begin
       Top:=Top+dY;
       Left:=Left+dX;
   end;

   if (dX+dY)<>0 then Picture.Assign(Grafika[Faze,Smer]);
end;
    ////////////////////////////////////////////////////////////////////

procedure TWokno.Save(Sender: TObject);
var FSave: File of GamePosition;
    Savey: array[1..4] of GamePosition;
    Ted: GamePosition;
    i,j, cislo: integer;
begin
  cislo:=StrToInt(TMenuItem(Sender).Name[4]);  //priprav si co budes ukladat
  //vem z Pampucha co potrebujes
  Ted.Top:=Pampusak.Top;
  Ted.Left:=Pampusak.Left;
  Ted.dX:=Pampusak.dX;
  Ted.dY:=Pampusak.dY;
  Ted.mX:=Pampusak.mX;
  Ted.mY:=Pampusak.mY;
  Ted.mX0:=Pampusak.mX0;
  Ted.mY0:=Pampusak.mY0;
  Ted.Faze:=Pampusak.Faze;
  Ted.Stopped:=Pampusak.Stopped;
  Ted.Smer:=Pampusak.Smer;
  Ted.Ziv:=Pampusak.Ziv;
  Ted.Zivotu:=Pampusak.Zivotu;
  Ted.Body:=Pampusak.Body;
  //vem z robotu co potrebujes
  for i:=1 to 4 do begin
         Ted.Rob[i].Top:=Roboti.Robot[i].Top;
         Ted.Rob[i].Left:=Roboti.Robot[i].Left;
         Ted.Rob[i].dX:=Roboti.Robot[i].dX;
         Ted.Rob[i].dY:=Roboti.Robot[i].dY;
         Ted.Rob[i].mX:=Roboti.Robot[i].mX;
         Ted.Rob[i].mY:=Roboti.Robot[i].mY;
         Ted.Rob[i].mX0:=Roboti.Robot[i].mX0;
         Ted.Rob[i].mY0:=Roboti.Robot[i].mY0;
         Ted.Rob[i].Faze:=Roboti.Robot[i].Faze;
         Ted.Rob[i].Stopped:=Roboti.Robot[i].Stopped;
         Ted.Rob[i].Smer:=Roboti.Robot[i].Smer;
         Ted.Rob[i].Typ:=Roboti.Robot[i].Typ;
  end;
  //vem ze Sveta co potrebujes
  Ted.Level:=Svet.Level;
  Ted.sMapa:=Svet.sMapa;
  Ted.Tecek:=Svet.Tecek;
  for i:=1 to 16 do for j:=1 to 24 do Ted.Mapa[i,j]:=Svet.Mapa[i,j].Hodnota;

  AssignFile(FSave, SAVE_FILE);       //nacti co tam je
  try
    Reset(FSave);
    for i:=1 to 4 do Read(FSave,Savey[i]);
    CloseFile(FSave);
  except
    on Exception do for i:=1 to 4 do Savey[i]:=Ted;
  end;
  Savey[cislo]:=Ted;  //danou pozici vymen

  ReWrite(FSave);                           //a uloz to zpatky
  for i:=1 to 4 do Write(FSave,Savey[i]);
  CloseFile(FSave);
end;

procedure TWokno.Load(Sender: TObject);
var FLoad: File of GamePosition;
    Ted: GamePosition;
    i,j, cislo: integer;
begin
  cislo:=StrToInt(TMenuItem(Sender).Name[4]);  //priprav si co budes nacitat

  AssignFile(FLoad, SAVE_FILE);       //nacti co tam je
  try
    Reset(FLoad);
    for i:=1 to cislo do Read(FLoad,Ted);
    CloseFile(FLoad);
  except
    on Exception do ShowMessage('Soubor nelze otevt!');
  end;

  //dej Pampuchovi co potrebuje
  Pampusak.Top:=Ted.Top;
  Pampusak.Left:=Ted.Left;
  Pampusak.dX:=Ted.dX;
  Pampusak.dY:=Ted.dY;
  Pampusak.mX:=Ted.mX;
  Pampusak.mY:=Ted.mY;
  Pampusak.mX0:=Ted.mX0;
  Pampusak.mY0:=Ted.mY0;
  Pampusak.Faze:=Ted.Faze;
  Pampusak.Stopped:=Ted.Stopped;
  Pampusak.Smer:=Ted.Smer;
  Pampusak.Ziv:=Ted.Ziv;
  Pampusak.Zivotu:=Ted.Zivotu;
  Pampusak.Body:=Ted.Body;
  Pampusak.KamChci:=0;
  //dej robotu co potrebuje
  for i:=1 to 4 do begin
         Roboti.Robot[i].Top:=Ted.Rob[i].Top;
         Roboti.Robot[i].Left:=Ted.Rob[i].Left;
         Roboti.Robot[i].dX:=Ted.Rob[i].dX;
         Roboti.Robot[i].dY:=Ted.Rob[i].dY;
         Roboti.Robot[i].mX:=Ted.Rob[i].mX;
         Roboti.Robot[i].mY:=Ted.Rob[i].mY;
         Roboti.Robot[i].mX0:=Ted.Rob[i].mX0;
         Roboti.Robot[i].mY0:=Ted.Rob[i].mY0;
         Roboti.Robot[i].Faze:=Ted.Rob[i].Faze;
         Roboti.Robot[i].Stopped:=Ted.Rob[i].Stopped;
         Roboti.Robot[i].Smer:=Ted.Rob[i].Smer;
         Roboti.Robot[i].Typ:=Ted.Rob[i].Typ;
  end;
  //dej Svetu co potrebuje
  Svet.Level:=Ted.Level;
  Svet.sMapa:=Ted.sMapa;
  Svet.Tecek:=Ted.Tecek;
  for i:=1 to 16 do for j:=1 to 24 do begin
    Svet.Mapa[i,j].Hodnota:=Ted.Mapa[i,j];
    Svet.Mapa[i,j].Picture.Assign(Svet.Grafika[Svet.Mapa[i,j].Hodnota]);
    case Ted.Mapa[i,j] of
        0: begin
             Svet.mapa[i,j].Visitable:=True;
             Svet.Mapa[i,j].Typ:=Void;
           end;
        STEN+1: begin
             Svet.mapa[i,j].Visitable:=True;
             Svet.Mapa[i,j].Typ:=Dot;
           end;
        else begin
             Svet.mapa[i,j].Visitable:=False;
             Svet.Mapa[i,j].Typ:=Wall;
           end;
    end;
  end;
  Pampusak.Picture.Assign(Pampusak.Grafika[Pampusak.Faze, Pampusak.Smer]);
  Pampusak.NastavZivoty;                                 //aktualizuj pocet zivotu
  Wokno.Points.Caption := IntToStr(Pampusak.Body);   //aktualizuj pocet bodu
  if Pampusak.Ziv or (Pampusak.Zivotu>0) then begin   //pokud je nazivu, nech ho zit
     Svet.Wait(WAITING);
     Pampusak.Transparent:=True;
  end;
  Svet.isRecord:=False;
  Svet.Recordable:=False;
  NewRecord.Visible:=False;

  Svet.Casovac.Enabled:=Wokno.Pause1.Caption = '&Pause';//pokud neni pouza, nech cas bezet
end;

procedure TWokno.abulka1Click(Sender: TObject);
begin
   Pause1Click(Sender);         //pesta hrt
   TabulkaNej.ShowModal;        //zobrazi tabulku a ceka na jej zaven
   Pause1Click(Sender);         //u zase hraj
end;

procedure TWokno.About1Click(Sender: TObject);
begin
   Pause1Click(Sender);         //pesta hrt
   About.ShowModal;
   Pause1Click(Sender);         //u zase hraj
end;

procedure TWokno.Open1Click(Sender: TObject);     //nati uivatelskou mapu...
begin
  Pause1Click(Sender);
  if not OpenDlg.Execute then begin
    Pause1Click(Sender);
    exit;
  end;
  Nov1Click(Sender);
  Svet.Recordable:=False;
  Svet.sMapa:= OpenDlg.FileName;
  Svet.Level:=-1;
  Svet.NactiMapu;

  Pause1Click(Sender);
end;

end.
